//********************************************************************
//*** ResourcePool/SQL/SQLSelect.hh
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: SQLSelect.hh,v 1.11 2008/04/21 17:39:10 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_SQL_SQLSELECT_HH
#define RESOURCEPOOL_SQL_SQLSELECT_HH

#include <string>

#include "ResourcePool/SQL/SQLFetcher.hh"

namespace fatalmind {

/**
 * This class provides the ability to perform a SQL query which returns an arbitary number of rows.
 *
 * You must supply a SQLFetcher object (by reference) which will be called for each record.
 * 
 * The reference to the supplied SQLFetcher object must remain valid though the complete lifetime
 * of the SQLSelect object.
 */
class SQLSelect {
	public:
		SQLSelect(SQL::SQLFetcher& a_fetcher) 
		: fetcher(a_fetcher)
		{
		}
		virtual ~SQLSelect() {
		}
	protected:
		SQL::SQLFetcher& fetcher;
};

}
#endif
